

#include <stdio.h>

#include "ad++.h"
#include "admacros.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ; {

  const int n = 7 ;

  Procs2 p(2, 3) ;
  //Range x(n, p.dim(0), STP) ;
  //Range y(n, p.dim(1), STP) ;
  StepRange x(n, p.dim(0)) ;
  StepRange y(n, p.dim(1)) ;
  Array2<float> a(x, y, p), b(y, x, p) ;

  ON(p) {

    Index i(x), j(y) ;

    WHERE(i) {
      WHERE(j) {
        a(i, j) = 10 * (1 + i) + 1 + j ;
      } EREWH(j) ;
    } EREWH(i) ;

    Array2<float> tmp1(x, y) ;
    WHERE(i) {
      WHERE(j) {
        tmp1(i, j) = a(i, j) + 2 ;
      } EREWH(j) ;
    } EREWH(i) ;

    remap(b, tmp1) ;

  } NO(p) ;

  // output

  gprintf("a\n") ;
  aprintf("%7.2f%*N", a, y.size()) ;


  gprintf("b\n") ;
  aprintf("%7.2f%*N", b, x.size()) ;

  } AdlibFinalize() ;
}


